<id>
Anti-Post Padding 1.3.x
</id>

<version>
0.3b
</version>

<mod info>
This mod disables post-padding on your forum. After making a post, if a user adds another post immediately after it, the new post does not get added as a new post, but is incorporated in the old post.

Things to note:
- Each new post is treated as a modification to the old post, and a 'Last Edit' message is displayed at the bottom of the post, with the time of the last post added.
- If the sum of the old and the new post exceeds the maximum message length for the board, the new post is posted in the normal fashion.
- This mod only works if the last post of the thread is made by the same user. So if there are two posters post-padding after each other, then it won't be very helpful.
- Guests are exempt from this check.
- The time limit after which a post-pad would be treated as a separate post is set by default to 12hours. You can change it in 'Edit Anti-Post Padding Settings' in Admin Centre.
- For each board in the list:
	- Set it to -1 (not zero) to disable this mod: Every post will then be treated as a new post.
	- Set it to 100000 to disable time limit: Every post will then be appended to the previous post.
	- You can also try fractions: 0.5 for a time limit of half an hour.. and so on..
- Enter the 'Forum Default' value for new boards and for boards that have no setting specified. (Forum default will be assumed to be 12h if left blank.)

Files modified:
english.lng
Sources/Admin.pl
Sources/AdminEdit.pl
Sources/ModifyMessage.pl
Sources/Post.pl
Sources/SubList.pl

Uninstall any previous version of this mod, apply the mod, upload these six files in ASCII, and enjoy!!

Version history:
v0.3: 	Board specific Time Limit option;
	Corrected bug causing change in topic title on appending first post.
	Corrected bugs related to default option and new boards.
v0.2: 	Added Time Limit option
</mod info>

<author>
longhairandabeard
</author>

<homepage>
http://www.su-aiims.com/nh/
</homepage>

<edit file>
english.lng
</edit file>

<search for>
$txt{'796'} = "Your Instant Messages:";
</search for>

<add after>

$app_txt{'01'} = "Here you can enter <b>Anti-Post Padding Settings</b> for each board.<br><br>For each board, enter the time in <b>hours</b> after which a post-pad should appear separately<br>Set to <b>-1</b> (not zero) if you want all post-pads to appear separately.<br>Set to <b>100000 </b>if you want all post-pads to appear appended to the original post.<br><b>Fractions</b> like 1.5 for one and a half hour can also be entered.<br><br>Enter the <b>Forum default</b> value for newly created boards and for boards for which you haven't entered values below.";
$app_txt{'02'} = "Boards";
$app_txt{'03'} = "Time Limit";
$app_txt{'04'} = "Edit Anti-Post Padding Settings";
$app_txt{'05'} = "Here you can enter Anti-Post Padding Settings for each board.";
$app_txt{'06'} = "Board default";
</add after>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size="1">
        - <a href="$cgi;action=modsettings">$txt{'222'}</a><br>
</search for>

<add after>
	- <a href="$cgi;action=appsettings">$app_txt{'04'}</a><br>
</add after>

<edit file>
Sources/AdminEdit.pl
</edit file>

<search for>
$admineditplver = "1 Gold - SP 1.3.1";
</search for>

<add after>

sub AppSettingsEdit {
	&is_admin;
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		$cataccess{$curcat} = <FILE>;
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		push(@allboards,@{$catboards{$curcat}});
	}
	chomp @allboards;
	fopen(FILE, "$vardir/app_settings.txt");
	$app_default = <FILE>;
	@appsettings = <FILE>;
	fclose(FILE);
	foreach $curappsetting (@appsettings) {
		chomp $curappsetting;
		($appboard,$tmpa) = split(/\|/, $curappsetting);
		$appsetting{$appboard} = $tmpa;
		}
	my $counter=0;
	foreach $curboard (@allboards) {
		$counter++;
		fopen(FILE, "$boardsdir/$curboard.dat") || fatal_error("Cannot open $curboard.dat");
		$boardname{$curboard} = <FILE>;
		fclose(FILE);
		$appstuff .= qq~
<tr>
    <td width="50%" class="windowbg2" bgcolor="$color{'windowbg2'} align="left">
    <font size=2>$boardname{$curboard}</font></td>
    <input type=hidden name="boardname$counter" value="$curboard">
    <td width="50%" class="windowbg2" bgcolor="$color{'windowbg2'} align="left">
    <font size=2><input type=text name="appsetting$counter" value="$appsetting{$curboard}" size=10></font></td>
  </tr>~;
	}
		
	$yymain .= qq~
<form action="$cgi;action=appsettings2" method="POST">
<table border="0" width="90%" cellspacing="1" cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2">
    <font size="2" class="text1" color="$color{'titletext'}"><b>$app_txt{'04'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" colspan="2">
    <font size="1">$app_txt{'01'}</font></td>
  </tr><tr>
    <td width="50%" class="windowbg" bgcolor="$color{'windowbg'} align="left">
    <font size=2><b>$app_txt{'02'}</b></font></td>
    <td width="50%" class="windowbg" bgcolor="$color{'windowbg'} align="left">
    <font size=2><b>$app_txt{'03'}</b></font></td>
  </tr><tr>
    <td width="50%" class="windowbg2" bgcolor="$color{'windowbg2'} align="left">
    <font size=2><b>$app_txt{'06'}</b></font></td>
    <td width="50%" class="windowbg2" bgcolor="$color{'windowbg2'} align="left">
    <font size=2><input type=text name="appdefault" value="$app_default" size=10></font></td>
  </tr>$appstuff<tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" colspan="2" align="center">
    <input type=hidden name=counter value="$counter">
    <input type=submit value=$txt{'10'}></td>
</table>
</form>
	~;
	$yytitle = "$app_txt{'04'}";
	&template;
	exit;
}

sub AppSettingsEdit2 {
	&is_admin;
	my $counter = $FORM{'counter'};
	$appsettings[0] = $FORM{'appdefault'} || 12;
	for ($counter2 = 1; $counter2<=$counter; $counter2++) {
		$boardname = "boardname".$counter2;
		$appsetting = "appsetting".$counter2;
		$appsettings[$counter2] = $FORM{$boardname}."|".$FORM{$appsetting};
	}
	fopen(FILE, ">$vardir/app_settings.txt");
	for ($counter2 = 0; $counter2<=@appsettings; $counter2++) {
		print FILE "$appsettings[$counter2]\n";
	}
	fclose(FILE);

	$yySetLocation = qq~$cgi\;action=appsettings~;
	&redirectexit;
}	
</add after>

<edit file>
Sources/ModifyMessage.pl
</edit file>

<search for>
	# Make sure the user is allowed to edit this post.
	if( $postid >= 0 && $postid < @messages ) {
		chomp $messages[$postid];
</search for>

<add before>

	if ($app_app == 1) { $postid = $app_postid }

</add before>

<search for>
		if( $postid == 0 ) {
			$tsub = $subject;
			$ticon = $icon;
		}
</search for>

<replace>
		if ($app_app == 1) {
			$message = $app_message;
			$subject = $app_sub;
		}
		else {
		if( $postid == 0 ) {
			$tsub = $subject;
			$ticon = $icon;
		}
		}
</replace>

<edit file>
Sources/Post.pl
</edit file>

<search for>
	if(-e("$datadir/.txt")) { unlink("$datadir/.txt"); }
</search for>

<add after>

	my( @app_messages, @app_settings, $app_board, $app_boardcheck, $app_name, $app_email, $app_date, $app_username, $app_icon, $app_Attach, $app_ip, $app_postmessage, $app_ns, $app_lm, $app_lmb, $app_tlimit, $app_tpost, $app_tpost1, $app_tdiff );
	if ($threadid ne '') { 
		fopen(FILE, "$datadir/$threadid.txt") || &fatal_error("212 $txt{'106'}: $txt{'23'} $threadid.txt");
		@app_messages = <FILE>;
		fclose (FILE);
		if (-e("$vardir/app_settings.txt")) {
			fopen(FILE, "$vardir/app_settings.txt");
			$app_default = <FILE>;
			@app_settings = <FILE>;
			fclose(FILE);
			chomp @app_settings;
			for ($i=0; $i<@app_settings; $i++) {
				($appboardname, $appsetting) = split(/\|/, $app_settings[$i]);
				if ($appboardname eq $currentboard) { $app_tlimit = 3600*$appsetting; }
			}
			if (!$app_tlimit) { $app_tlimit = 3600*$app_default; } #if new board, or value not entered for a particular board
		}
		if (!$app_tlimit) { $app_tlimit = 43200; } #if app_settings.txt does not exist, or default value is not set
		$app_postid = 0;
		$app_postid = @app_messages - 1;
		chomp $app_messages[$app_postid];
		($app_sub, $app_name, $app_email, $app_date, $app_username, $app_icon, $app_attach, $app_ip, $app_postmessage, $app_ns, $app_lm, $app_lmb) = split(/[\|]/, $app_messages[$app_postid]);
		if ($app_lm) { $app_tpost = $app_lm } else { $app_tpost = $app_date }
		$app_tpost1 = stringtotime($app_tpost);
		$app_tdiff = time - $app_tpost1;
		$app_message = $app_postmessage.'<br><br>[hr]<br>'.$message;
		$app_app = 0;
		if ($username eq $app_username && $username ne 'Guest' && length($app_message)<$MaxMessLen && $app_tdiff <= $app_tlimit) {
			$app_app = 1;
			require "$sourcedir/ModifyMessage.pl";
			&ModifyMessage2;
		}
	}
</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'usersrecentposts',"Profile.pl&usersrecentposts");
</search for>

<add before>
'appsettings',"AdminEdit.pl&AppSettingsEdit",
'appsettings2',"AdminEdit.pl&AppSettingsEdit2",
</add before>